//------- Max_conv.CPP ---------------------------------------------------------------
#pragma once
#include "stdafx.h"
#include "Max_conv.h"	//-       .
//------------------------------------------------------------------------------------





//=====================================================================================================
// - 
//=====================================================================================================
//  MIX 
extern "C" IMIXEDMODEL __declspec(dllexport) *createmixedmodel(CHAR *device, ILICENCESERVER *ils)
{
	if(ils->authorize(model_key))		//     createdsimmodel
	{
	//	MessageBoxA(0," !", "!",MB_ICONERROR);
		return new Max_conv;			// -     
	} else {
		MessageBoxA(0,"   : [NULL]!", "!",MB_ICONERROR);
		return NULL;
	}
}
//---------------------------------------------------------------------------
//   PROSPICE,     .     , 
//   ,   .
extern "C" VOID __declspec(dllexport) deletemixedmodel(IMIXEDMODEL *model)
{
	delete (Max_conv *)model;	// -   IDSIMMODEL ,      createdsimmodel.
}
//---------------------------------------------------------------------------







//------------------------------------------------------------------------------------
// 
Max_conv::Max_conv()
: TxData(0)
, InCS(false)
, InCLK(0)
{
	centr = 0;	
	setpoint = 0;
	OuDat = 0;
}
//   
INT Max_conv::isanalog(CHAR *pinname)
{
	if((strcmp(pinname, "T+")==0)||(strcmp(pinname, "T-")==0))
		return 1;	// 1 =     
	else 			// 1      .
		return 0;	// 0       .
}					// -1     ,   ,    .
//   
INT Max_conv::isdigital(CHAR *pinname)
{
	if((strcmp(pinname, "CS")==0)||(strcmp(pinname, "CLK")==0)||(strcmp(pinname, "SDO")==0))
		return 1;
	else
		return 0;
}
//   
VOID Max_conv::setup(IINSTANCE *instance, ISPICECKT *dsimckt)
{
	inst = instance;					// ,     
	ckt = dsimckt;						//   .
//       IINSTANCE::getdsimpin,     ,     .
	PinTP = inst->getspicenode("T+", true);	//       
	PinTM = inst->getspicenode("T-", true);	//   
}
//   
VOID Max_conv::setup(IINSTANCE* instd, IDSIMCKT *dsim)
{
	instd_ = instd;					// ,     
	cktd = dsim;					//   .

	PinCS = instd_->getdsimpin("CS", true);		// CS    
	PinSCK = instd_->getdsimpin("CLK", true);	//
	PinSDO = instd_->getdsimpin("SDO", true);	//

//    : (   ,     "Q"  "0")
	PinSDO->setstate(SLO);				//  3 
// 10 \-12 = 1, \-9 = 1, \-6 = 1, \-3 = 1
	re_time = false;
	cktd->setcallback(200000000000, this, 0x25);	//    (event) 0x25.      FFDEVICE::callback (time, eventid)
}
//     
VOID Max_conv::runctrl(RUNMODES mode)
{
}
//      ()
VOID Max_conv::actuate(REALTIME time, ACTIVESTATE newstate)
{
//   (ACTIVESTATE newstate)
}
//      
BOOL Max_conv::indicate(REALTIME time, ACTIVEDATA* data)
{
//   (ACTIVEDATA *data).        (.VSMSDK.HLP). 
	return TRUE;
}
//       . 
VOID Max_conv::dcload(REALTIME time, SPICEMODES mode, DOUBLE *oldrhs, DOUBLE *newrhs)
{
}
//      . 
VOID Max_conv::acload(SPICEFREQ omega, DOUBLE *rhs, DOUBLE *irhs)
{
}
//     .
VOID Max_conv::trunc(REALTIME time,  REALTIME *newtimestep)
{
}
//           RHS.
VOID Max_conv::accept(REALTIME time, DOUBLE *rhs)
{
	if(re_time == 1)
	{
		DOUBLE vl = 0;
		re_time = false;
		vl = rhs[PinTP] - rhs[PinTM];			//   
		OuDat = 0;								//   
		if((int)(rhs[PinTP]+0.001) == 5)		//    VDD
			OuDat |= 0x0104;
		if((int)rhs[PinTM] == 0)				//    GND
			OuDat |= 0x0102;
		if(vl > 2.5)							//   
			OuDat |= 0x0101;
		OuDat |= GetIntTemp(setpoint);			//     t

		if(vl != oldvoltege)					//   
		{
			oldvoltege = vl;
			voltage = vl * 24819;				//  
		}
		OuDat |= GetExtTemp(voltage);			//    t  
	}
}
//    DSIM               .
VOID Max_conv::simulate(ABSTIME time, DSIMMODES mode)
{
	if(mode != 16)
	{	
		STATE stSDO;
		if(PinCS->istate() == WLO)				//    
		{
			if(InCS == false)					//    
			{
				InCS = true;					//    
				TxData = OuDat;					//  t   
				InCLK = 0;
			}
			if((PinSCK->istate() == WHI) && (InCLK == 1))
				InCLK++;
			if((PinSCK->istate() == WLO) && (InCLK == 3))
				InCLK = 0;

			switch(InCLK)						//    
			{
				case 0:	if((TxData & 0x80000000) == 0x80000000)	//   
							stSDO = PHI;
						else
							stSDO = PLO;
						PinSDO->setstate(time+1000, 400, 400, TSTATE, stSDO);
						InCLK++;
						break;
				case 1:	break;
				case 2:	TxData = TxData<<1;	InCLK++;	break;
				case 3: break;
				default: inst->warning("   SPI ");
			}
		} else {
			InCS = false;						// CS -> HI,    
			PinSDO->setstate(time+1000, 400, 400, TSTATE, FLT);
		}
	}
}
//        IDSIMCKT::setcallback 
VOID Max_conv::callback(ABSTIME time, EVENTID eventid)
{
	if(eventid == 0x25)		//     :
	{
		if(PinSDO->getstate()==PLO)
			PinSDO->setstate(time+100, 400, 400, TSTATE, PHI);
		else
			PinSDO->setstate(time+100, 400, 400, TSTATE, PLO);
		re_time = true;
		cktd->setcallback(time + 70000000000, this, 0x25); //   70ms
	}
}
//=====================================================================================================












//=====================================================================================================
//  
//=====================================================================================================
//  
//   
extern "C" IACTIVEMODEL __declspec(dllexport) *createactivemodel(CHAR* device, ILICENCESERVER* ils)
{
	if(ils->authorize(model_key))		//     createdsimmodel
	{
	//	MessageBoxA(0," !", "!",MB_ICONERROR);
		return new Max_conv;			// -     
	} else {
		MessageBoxA(0,"   : [NULL]!", "!",MB_ICONERROR);
		return NULL;
	}
}
//   
extern "C" VOID __declspec(dllexport) deleteactivemodel(IACTIVEMODEL* model)
{
	delete (Max_conv*)model;	// - 
}
//------------------------------------------------------------------------------------




//------------------------------------------------------------------------------------
//    ****************************************************************
//------------------------------------------------------------------------------------
//       
VOID Max_conv::initialize(ICOMPONENT *cpt)
{
	component = cpt;						//   IComponent-   
	component->getsymbolarea(1,&lcdarea);	//  

//	component->setpenwidth(0);				//   
//	component->setpencolour(BLACK);			//   
//	component->setbrushcolour(BLACK);		//   
//	component->setbold(1);					//  
//	component->settextcolour(RGB(255,0,0));	//  
//	component->settextsize(323);			//  

	centr = (lcdarea.right - lcdarea.left)/2+lcdarea.left;	//      
}
//  PROSPICE,     
ISPICEMODEL* Max_conv::getspicemodel(CHAR* primitive)
{
	return this;
//	return (IMIXEDMODEL*)this;
}
//  PROSPICE,    
IDSIMMODEL* Max_conv::getdsimmodel(CHAR* primitive)
{
	return this;
//	return (IMIXEDMODEL*)this;
}
// ,      ( )
VOID Max_conv::plot(ACTIVESTATE state)
{
	component->drawsymbol(-1);		//    -1    

	CString str, strf;
	setpoint = atof(component->getprop("SETPOINT"));
	strf = component->getprop("FORMAT");
	int fi = strf.Find(".");
	if(fi != -1)
	{
		strf.Delete(0, fi+1);		//   
		strf.Insert(0, "%#.");
		strf.Insert(5, "f");
		str.Format(strf, setpoint);
	} else {
		str.Format("%f", setpoint);
	}
	component->drawtext(centr, lcdarea.top+5, 0, TXJ_CENTRE, str.GetBuffer());
}
// ,      ,      
VOID Max_conv::animate(INT element, ACTIVEDATA* newstate)
{
}
//       
BOOL Max_conv::actuate(WORD key, INT x, INT y, DWORD flags)
{
	CString str;
	if(flags == 65536)				//    
	{
		if(setpoint >= atoi(component->getprop("MAX")))		//  
			return FALSE;
		setpoint += atof(component->getprop("STEP"));		//   
		str.Format("%f", setpoint);
		component->addprop("SETPOINT", str.GetBuffer(), HIDE_ALL);
		return TRUE;
	} else if(flags == 131072)		//    
	{
		if(setpoint <= atoi(component->getprop("MIN")))		//  
			return FALSE;
		setpoint -= atof(component->getprop("STEP"));		// 
		str.Format("%f", setpoint);
		component->addprop("SETPOINT", str.GetBuffer(), HIDE_ALL);
		return TRUE;
	}
	return FALSE;
}
//------------------------------------------------------------------------------------








//=====================================================================================================
//   
//=====================================================================================================
//    
unsigned int Max_conv::GetIntTemp(DOUBLE setpoint)
{
	unsigned int trmp = 0;
	unsigned int dc = 0;
	if(setpoint < 0)
	{
		trmp = setpoint - 0.00000000001;		//   
		dc = (((setpoint-0.0000000001) - (DOUBLE)trmp)*15.5);	//   
		dc = dc & 0x00FF;
		if(trmp == 0)							//   "0"   t
			trmp = 0xFFFF;
		if(dc != 0)								//   "0",     ","
			dc = 16 - (256 - dc);				//  0  15 (0x00 - 0xFF)
	} else {
		trmp = setpoint + 0.0000000001;			//   
		dc = (float)((setpoint+0.0000000001) - (DOUBLE)trmp)*(float)15.5;	//   
	}
	trmp = ((trmp<<8) & 0xFF00) | (dc<<4);		//   datasheet
	
	return trmp;
}
//   
unsigned int Max_conv::GetExtTemp(DOUBLE volt)
{
	unsigned int trmp = 0;
	int dc = 0;
	if(volt < 0)
	{
		trmp = volt - 0.001;				//   
		dc = (((volt-0.001) - (DOUBLE)trmp)*4);	//   
		dc = dc & 0x03;
		if(trmp == 0)							//   "0"   t
			trmp = 0xFFFF;
	} else {
		trmp = volt + 0.001;				//   
		dc = (((volt+0.001) - (DOUBLE)trmp)*4);		//   
	}
	trmp = ((trmp<<20) & 0xFFF00000) | (dc<<18);

	return trmp;
}
