//-----   Max_conv.h ------------------------------------
#pragma once
#include "vsm.hpp"

#define model_key 0x00000000 // -    Labcenter Electronics


class Max_conv : public IMIXEDMODEL, public IACTIVEMODEL
{
 public:
	Max_conv();
	INT isanalog(CHAR *pinname);
	INT isdigital(CHAR *pinname);
	VOID runctrl(RUNMODES mode);
	VOID actuate(REALTIME time, ACTIVESTATE newstate);
	BOOL indicate(REALTIME time, ACTIVEDATA *data);
	VOID setup(IINSTANCE* inst, ISPICECKT *dsim);
	VOID setup(IINSTANCE* instd, IDSIMCKT *dsim);
	VOID dcload(REALTIME time, SPICEMODES mode, DOUBLE *oldrhs, DOUBLE *newrhs);
	VOID acload(SPICEFREQ omega, DOUBLE *rhs, DOUBLE *irhs);
	VOID trunc(REALTIME time,  REALTIME *newtimestep);
	VOID accept(REALTIME time, DOUBLE *rhs);
	VOID simulate (ABSTIME time, DSIMMODES mode);
	VOID callback (ABSTIME time, EVENTID eventid);
 //  
	VOID initialize(ICOMPONENT* cpt);
	ISPICEMODEL* getspicemodel(CHAR* primitive);
	IDSIMMODEL* getdsimmodel(CHAR* primitive);
	VOID plot(ACTIVESTATE state);
	VOID animate(INT element, ACTIVEDATA* newstate);
	BOOL actuate(WORD key, INT x, INT y, DWORD flags);

 private:
	IINSTANCE* inst;		//    
	ISPICECKT* ckt;
	IINSTANCE* instd_;		//    
	IDSIMCKT* cktd;
	 
	SPICENODE PinTP;		//  
	SPICENODE PinTM;
	IDSIMPIN* PinCS;		//  
	IDSIMPIN* PinSCK;
	IDSIMPIN* PinSDO;

	DOUBLE voltage;			//    
	DOUBLE oldvoltege;		//    
	BOOL re_time;			//   

	unsigned int OuDat;		//      
	unsigned int TxData;	//  
//  
	ICOMPONENT* component;	// ISIS    
	BOX lcdarea;			//    t

public:	
	DOUBLE setpoint;		//  
	int centr;				//    t

	unsigned int GetIntTemp(DOUBLE setpoint);	//    
	unsigned int GetExtTemp(DOUBLE volt);		//   

	bool InCS;				// 1 =    LO   CS
	int InCLK;				//    
};
